Summary: Daemon for controlling PPP connection
Name: dwun
Version: 0.8g
Release: 1
Copyright: MIT
Group: System Environment/Daemons
Source: http://download.sourceforge.net/dwun/%{name}-%{version}.tar.gz
BuildRoot: /var/tmp/%{name}-buildroot

%description
Dwun is a program that is usually used to bring a PPP connection up when clients
wish the link to be available up, and down when no authenticated clients remain
that want the link up.
    
Since it can enable/disable run commands when clients run the CONNECT or 
DISCONNECT commands, dwun can be used without pppd as a generic daemon to run 
user-specified commands. One example of this is using dwun to control firewall 
rules with user authentication.

%prep
%setup -q

%build
./configure --prefix=$RPM_BUILD_ROOT/usr --with-docdir=doc/%{name}-%{version}-%{release}
make

%install
rm -rf $RPM_BUILD_ROOT
make install-strip

mkdir -p $RPM_BUILD_ROOT/etc
mkdir -p $RPM_BUILD_ROOT/etc/rc.d/init.d
install -m 644 rpm/dwunrc $RPM_BUILD_ROOT/etc/dwunrc
install -m 600 rpm/dwunauth $RPM_BUILD_ROOT/etc/dwunauth
install -m 755 rpm/dwun.init $RPM_BUILD_ROOT/etc/rc.d/init.d/dwun

# TODO: if your distribution has /etc/ppp/ip-up.d, you should uncomment the
# following line and remove the %post and %postun scripts
#install -m 755 rpm/dwun.ip-up $RPM_BUILD_ROOT/etc/ppp/ip-up.d/dwun

%clean
rm -rf $RPM_BUILD_ROOT

# FIXME: /usr/doc stuff should be %doc'ed.
%files
%config /etc/*
%doc /usr/man/*/*
/usr/doc/%{name}-%{version}-%{release}/*
%dir /usr/doc/%{name}-%{version}-%{release}
/usr/bin/*
/usr/sbin/*

%post
# ugly. Should use /etc/ppp/ip-up.d/dwun for distros that support it.
#!/bin/sh
set -e

IP_UP=/etc/ppp/ip-up
IP_UP_OLD=$IP_UP.dwun-old
if [ -f $IP_UP_OLD ]; then
	exit 0
fi
# Add script to the beginning of /etc/ppp/ip-up
cp -p $IP_UP $IP_UP_OLD
cat > $IP_UP << EOF
#!/bin/sh
#
# Notify dwun if connection is up.
# Written by Tim Sutherland <timsuth@ihug.co.nz>
#
CHECKIP=198.186.203.55 # linux.com
CHECKIP2=204.71.200.243 # one of www.yahoo.com

if ( ! ping -c 1 \$CHECKIP && ! ping -c 1 \$CHECKIP2 )
then
	#echo '%%con:#Bad connection' > /usr/lib/dwun-msg
	kill -USR2 \`cat /var/run/dwun.pid\`
	exit 1
fi
kill -USR1 \`cat /var/run/dwun.pid\`
EOF

# add rest of ip-up back in
sed 1d $IP_UP.dwun-old >> $IP_UP

%postun
#!/bin/sh
set -e

IP_UP=/etc/ppp/ip-up
IP_UP_OLD=$IP_UP.dwun-old
if [ -f $IP_UP_OLD ]; then
	mv $IP_UP_OLD $IP_UP
fi
